//*****************************************************************************************************
//  1. t@C
//		DialogEx.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		g_CAONX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//		g@\͎̒ʂ
//		EEBhETCYύX\ɂATCYύXɔĊeRg[ĔzuB
//		E[hX_CAOT|[gB
//		EXe[^Xo[tB
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "DialogEx.h"


// CDialogEx _CAO

IMPLEMENT_DYNAMIC(CDialogEx, CDialog)

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::CDialogEx
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nID				[I] _CAOID
//		CWnd		*pParent		[I] eEBhEւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CDialogEx::CDialogEx(UINT nID, CWnd *pParent)
	: CDialog(nID, pParent)
{
	// oϐ
	m_nID = nID;
	m_pParent = pParent;
	m_bModeless = FALSE;
	m_sizeDlg = 0;
	m_bStatusBar = FALSE;
	m_bSizeChange = FALSE;
}

void CDialogEx::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDialogEx, CDialog)
	ON_WM_SIZE()
	ON_MESSAGE(WM_EXITSIZEMOVE, OnExitSizeMove)
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


//*****************************************************************************************************
//  1. ֐
//		CDialogEx::DoModeless
//----------------------------------------------------------------------------------------------------
//  2. @\
//		[hXŃ_CAOJ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDialogEx::DoModeless()
{
	// [hXŃEBhE쐬
	if (!CDialog::Create(m_nID, m_pParent))
		return FALSE;

	// [hXtOZbg
	m_bModeless = TRUE;

	// EBhE\
	ShowWindow(SW_SHOW);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CDialogEx::OnInitDialog()
{
	CDialog::OnInitDialog();

	// EBhETCYۑ
	CRect rect;
	GetClientRect(rect);
	m_sizeDlg = rect.Size();

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::OnCancel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		LZ{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::OnCancel()
{
	if (m_bModeless)
		DestroyWindow();
	else
		EndDialog(IDCANCEL);
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::OnOK
//----------------------------------------------------------------------------------------------------
//  2. @\
//		OK{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::OnOK()
{
	// Ȃ
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::PostNcDestroy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::PostNcDestroy()
{
	CDialog::PostNcDestroy();

	// [hXȂ玩g
	if (m_bModeless)
		delete this;
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::SetCtlPosition
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Rg[ʒuݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nID				[I] Rg[ID
//		double		fLeft			[I] ʒu
//		double		fTop			[I] ʒu
//		double		fRight			[I] Eʒu
//		double		fBottom			[I] ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::SetCtlPosition(UINT nID, double fLeft, double fTop, double fRight, double fBottom)
{
	SetCtlPosition(GetDlgItem(nID), fLeft, fTop, fRight, fBottom);
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::SetCtlPosition
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Rg[ʒuݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd		*pWnd			[I] Rg[̃EBhE|C^
//		double		fLeft			[I] ʒu
//		double		fTop			[I] ʒu
//		double		fRight			[I] Eʒu
//		double		fBottom			[I] ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::SetCtlPosition(CWnd *pWnd, double fLeft, double fTop, double fRight, double fBottom)
{
	HWND hWnd = pWnd->GetSafeHwnd();
	if (hWnd == NULL)
		return;

	// ݒ\̂ɐݒ
	SDlgCtlPosition cDlgCtlPosition;
	cDlgCtlPosition.hWnd = hWnd;
	cDlgCtlPosition.fLeft = fLeft;
	cDlgCtlPosition.fTop = fTop;
	cDlgCtlPosition.fRight = fRight;
	cDlgCtlPosition.fBottom = fBottom;

	// ݂̃EBhEʒu擾
	WINDOWPLACEMENT wp;
	pWnd->GetWindowPlacement(&wp);
	cDlgCtlPosition.rectCtl = wp.rcNormalPosition;

	int nSize = (int)m_aDlgCtlPosition.GetSize();
	for (int i = 0; i < nSize; i++) {
		if (m_aDlgCtlPosition[i].hWnd == hWnd) {
			// zɐݒ㏑
			m_aDlgCtlPosition[i] = cDlgCtlPosition;
			return;
		}
	}

	// zɐݒǉ
	m_aDlgCtlPosition.Add(cDlgCtlPosition);
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::SetAllCtlPosition
//----------------------------------------------------------------------------------------------------
//  2. @\
//		SRg[ʒuݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fLeft			[I] ʒu
//		double		fTop			[I] ʒu
//		double		fRight			[I] Eʒu
//		double		fBottom			[I] ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::SetAllCtlPosition(double fLeft, double fTop, double fRight, double fBottom)
{
	CWnd *pWnd = GetTopWindow();
	while (pWnd != NULL) {
		SetCtlPosition(pWnd, fLeft, fTop, fRight, fBottom);
		pWnd = pWnd->GetNextWindow();
	}	
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::OnSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhETCYύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nType			[I] TCYύX̃^Cv
//		int		cx				[I] EBhE̕
//		int		cy				[I] EBhE̍
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// Xe[^Xo[Ĕzu
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	// _CAORg[K؂ȈʒuɍĔzu
	if (m_sizeDlg.cx && cx != 0) {
		// TCY̍
		int nx = cx - m_sizeDlg.cx;
		int ny = cy - m_sizeDlg.cy;

		// ύXꂽTCY_CAÕRg[̑傫ƈʒuύX
		int nDlgCtlPosition = (int)m_aDlgCtlPosition.GetSize();
		for (int i = 0; i < nDlgCtlPosition; i++) {
			// qEBhE擾
			SDlgCtlPosition &cDlgCtlPosition = m_aDlgCtlPosition[i];
			CWnd *pWnd = FromHandle(m_aDlgCtlPosition[i].hWnd);

			// qEBhËʒuA傫擾
			CRect rect(cDlgCtlPosition.rectCtl);

			// ʒuƑ傫𒲐
			rect.left += (int)(nx * cDlgCtlPosition.fLeft);
			rect.top += (int)(ny * cDlgCtlPosition.fTop);
			rect.right += (int)(nx * cDlgCtlPosition.fRight);
			rect.bottom += (int)(ny * cDlgCtlPosition.fBottom);

			// qEBhEړ
			pWnd->SetWindowPos(NULL, rect.left, rect.top, rect.Width(), rect.Height(), SWP_NOZORDER);
		}

		// TCYύXtOON
		m_bSizeChange = TRUE;

		Invalidate(FALSE);

		UpdateWindow();
	}

	if (m_bStatusBar)
		RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::OnExitSizeMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhETCYύXAړI
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM		wParam		[I] EBhEbZ[Wp[^
//		LPARAM		lParam		[I] EBhEbZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		0
//*****************************************************************************************************
LRESULT CDialogEx::OnExitSizeMove(WPARAM wParam, LPARAM lParam)
{
	// TCYύXtOONȂ_CAOĕ\
	if (m_bSizeChange) {
		Invalidate();
		m_bSizeChange = FALSE;
	}

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::OnGetMinMaxInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhETCY擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MINMAXINFO		*lpMMI		[I] EBhEŏAő剻TCY
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::OnGetMinMaxInfo(MINMAXINFO *lpMMI)
{
	// EBhE̍ŏTCYݒ
	if (m_sizeDlg.cx != 0) {
		lpMMI->ptMinTrackSize.x = m_sizeDlg.cx;
		lpMMI->ptMinTrackSize.y = m_sizeDlg.cy;
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::CreateStatusBar
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xe[^Xo[쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::CreateStatusBar()
{
	if (m_wndStatusBar.Create(this)) {
		m_bStatusBar = TRUE;
		const UINT ind[2] = {0};

		m_wndStatusBar.SetIndicators(ind, 1);
		m_wndStatusBar.SetPaneInfo(0, 0, SBPS_STRETCH, 0);

		RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

		CRect rectStatusBar;
		m_wndStatusBar.GetWindowRect(rectStatusBar);

		CRect rectDialog;
		GetWindowRect(rectDialog);
		rectDialog.bottom += rectStatusBar.Height();
		MoveWindow(rectDialog, FALSE);

		// EBhETCYۑ
		GetClientRect(rectDialog);
		m_sizeDlg = rectDialog.Size();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CDialogEx::SetStatusBar
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xe[^Xo[ɕ\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pText		[I] Xe[^Xo[ɕ\镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDialogEx::SetStatusBar(LPCTSTR pText)
{
	m_wndStatusBar.SetPaneText(0, pText);
}
